<template>
  <div class="restaurant-list">
    <template v-if="loading">
      <restaurant-item :key="'lp-' + i" v-for="i in 3" />
    </template>
    <template v-else>
      <template v-if="strategy === 'waiting'">
        <restaurant-item
          v-for="r in waitingAvailableRestaurants"
          :strategy="strategy"
          :key="r.id"
          :restaurant="r"
        />
        <div
          v-if="waitingUnAvailableRestaurants.length > 0"
          class="inactive-title content-small"
        >
          {{ $t("list.close") }}
        </div>
        <restaurant-item
          v-for="r in waitingUnAvailableRestaurants"
          :strategy="strategy"
          :key="r.id"
          :restaurant="r"
        />
      </template>
      <template v-else>
        <restaurant-item
          v-for="r in bookingAvailableRestaurants"
          :strategy="strategy"
          :key="r.id"
          :restaurant="r"
        />
        <div
          v-if="bookingUnAvailableRestaurants.length > 0"
          class="inactive-title content-small"
        >
          {{ $t("list.unavailable") }}
        </div>
        <restaurant-item
          v-for="r in bookingUnAvailableRestaurants"
          :strategy="strategy"
          :key="r.id"
          :restaurant="r"
        />
      </template>
    </template>
  </div>
</template>
<script>
import { mapState, mapGetters } from "vuex";
import RestaurantItem from "./RestaurantItem";
import { isNowBetween, isTimeBetween } from "@/utils";
import _ from "underscore";

export default {
  props: {
    restaurants: {
      required: true,
      type: Array
    },
    loading: {
      required: true,
      type: Boolean
    }
  },
  components: {
    RestaurantItem
  },
  methods: {
    serviceStrategy(restaurant) {
      const { delivery, booking, preorder, waiting } = this.filter.service;
      return (
        (restaurant.allowBooking && booking === true) ||
        (restaurant.allowTakeOut && preorder === true) ||
        (restaurant.allowSendingOut && delivery === true) ||
        (!restaurant.waitingDisabled && waiting === true)
      );
    }
  },
  computed: {
    ...mapGetters("group", ["sessionTime"]),
    ...mapState("group", ["filter"]),
    ...mapGetters("account", ["isVipMember"]),
    currentRestaurants() {
      const { type } = this.filter;
      if (type == "all") {
        return this.restaurants.filter(r => this.serviceStrategy(r));
      }
      return this.restaurants.filter(r => {
        return !!~r.restaurantTypes.indexOf(type) && this.serviceStrategy(r);
      });
    },
    waitingAvailableRestaurants() {
      const restaurants = this.currentRestaurants.filter(r => !r.closed);
      return _.sortBy(restaurants, "waitingOrder");
    },
    waitingUnAvailableRestaurants() {
      return _.sortBy(
        _.difference(this.currentRestaurants, this.waitingAvailableRestaurants),
        "waitingOrder"
      );
    },
    bookingAvailableRestaurants() {
      const restaurants = this.currentRestaurants.filter(
        r =>
          r.allowBooking &&
          r.slotsWithin(this.isVipMember, this.sessionTime).length
      );
      return _.sortBy(restaurants, r => r.bookingOrder(this.isVipMember));
    },
    bookingUnAvailableRestaurants() {
      return _.sortBy(
        _.difference(this.currentRestaurants, this.bookingAvailableRestaurants),
        r => r.bookingOrder(this.isVipMember)
      );
    },
    strategy() {
      return this.filter.strategy;
    }
  }
};
</script>
<style lang="scss" scoped>
.restaurant-list {
  margin-left: -10px;
  margin-right: -10px;
  @include media-breakpoint-up(md) {
    padding: 30px 0;
    display: flex;
    flex-flow: row wrap;
    margin-left: -15px;
    margin-right: -15px;
  }
}

.inactive-title {
  background-color: $color-genesis-white;
  padding: $grid-gutter-width/1.6 $grid-gutter-width/2 $grid-gutter-width/2.5;
  color: $color-pigeon-grey;

  @include media-breakpoint-up(md) {
    flex: 1 0 100%;
    background-color: transparent;
    padding: 0;
    margin: 40px 15px 30px 15px;
    color: $color-primary-black;
    font-size: 28px;
  }
}
</style>
